/*
 *    Query.java
 *    Copyright (C) 2000 Stuart Yeates 
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

// the package we're in
package org.nzdl.gsdl.hli;

import org.nzdl.gsdl.service.*;
import org.nzdl.gsdl.corba.gsdlInterface.*;
import org.nzdl.gsdl.util.*;

// java standard library classes used
import java.io.IOException;
import java.io.Serializable;
import java.lang.Cloneable;
import java.util.Vector;

/**
 * A high-level view of a Query
 *
 * @author stuart yeates (say1@cs.waikato.ac.nz)
 * @version $Revision: 2467 $
 * @see
 * @see
 * @see
 * 
 */

public class Query implements Cloneable, Serializable
{
  /** */
  Collection collection = null;

  /** */
  String queryString = "";
  
  /** */
  Vector docIDs = new Vector();

  /** */
  Vector documents = new Vector();

  /** */
  long numberOfHits = 0;

  /** */
  String[] queryTerms = null;

  /** */
  long[] termTermFequencies = null;
    
  Query(Collection collection, String queryString) {
    this.collection = collection;
    this.queryString = queryString;
  }

  void runQuery() {
    if (collection == null)
      throw new Error ("null collection in runQuery");
    if (queryString == null)
      throw new Error ("null queryString in runQuery");
    
//      // create the argument objects 
//      corbaFilterResponseHolder reposnse = 
//        NzdlCorbaFactory.createFilterResponseHolder();
//      corbaFilterRequest request = 
//        NzdlCorbaFactory.createQueryFilterRequest( queryString );
//      corbatext_t c_name = 
//        NzdlCorbaFactory.toCorbaText( collection.getName() );
//      corbaComErrorHolder c_err = 
//        NzdlCorbaFactory.createComErrorHolder();
    
//      // run the actual query
//      m_nzdlServer.filter( c_name, request, response, c_err );
//      if (c_err.value.value() != 0)
//        System.err.println("service() error " + c_err.value.value());  

//      // parse the results
//      numberOfHits = response.numDocs;
    
    
  }
  

  



  /**
   *
   * 
   * @exception java.io.IOException when ...
   * @param arg2 ... 
   * @param arg1 ...
   * @return ...
   * @see
   * @see
   */




  /**
   * Tests...
   *
   * 
   * @exception java.io.IOException when ...
   * @param args the arguments ...
   */

  public static void main(String args[]) throws IOException
  {

  }
}

